#include "prjlibs-c/standards.h"
#include <unistd.h>
#include <errno.h>
#include <sys/types.h>

#include "skalibs/include/stddjb.h"
#include "prjlibs-c/constants.h"
#include "drop_root.h"
#include "die.h"

void drop_root(void) {
  char const* s;
  uint64 x;
  unsigned int i;

  s=env_get("ROOT");
  if (s!=null) {
    if (chdir(s)!=0)
      strerr_die5sys(errstat, PROG, err_unable, err_chdirto, s, ": ");
    if (chroot(".")!=0)
      strerr_die5sys(errstat, PROG, err_unable, err_chrootto, s, ": ");
  }

  s=env_get("GID");
  if (s!=null) {
    gid_t g;
    i=uint64_scan(s, &x);
    if (i==0 || s[i]!='\0')
      strerr_die4x(100, PROG, ": ", var_gid, err_malformed);
    g=x;
    if (g<(gid_t)0 || (uint64)g!=x) die_overflow();
    if (setgid(g)!=0)
      strerr_die5sys(errstat, PROG, err_unable, err_setgidto, s, ": ");
  }

  s=env_get("UID");
  if (s!=null) {
    uid_t u;
    i=uint64_scan(s, &x);
    if (i==0 || s[i]!='\0')
      strerr_die4x(100, PROG, ": ", var_uid, err_malformed);
    u=x;
    if (u<(uid_t)0 || (uint64)u!=x) die_overflow();
    if (setuid(u)!=0)
      strerr_die5sys(errstat, PROG, err_unable, err_setuidto, s, ": ");
  }
}
